﻿using System;
using System.Diagnostics;
using System.IO;
using System.Windows.Forms;

namespace MyIntegrator
{
	/// <summary>
	/// Description of MainForm.
	/// </summary>
	public partial class MainForm : Form
	{
		public MainForm()
		{
			//
			// The InitializeComponent() call is required for Windows Forms designer support.
			//
			InitializeComponent();
			
			//
			// TODO: Add constructor code after the InitializeComponent() call.
			//
		}
		
		void MainFormLoad(object sender, EventArgs e)
		{
			
			//RTEINTPARMS 1,    3,      100,                  -1,   0.2,    0,     5,    100,      0,        0,            1,        0
			//         type, area, maxpeaks, data point bunching, start, stop, reset, valley, filter, baseline, scale factor, location, IP
 			
			var settings = new Settings();
			
			var fn = @"..\..\data.txt";
			var lines = File.ReadAllLines(fn);
			var signal = new Signal(lines.Length);
			var iPoint=0;
			foreach (var line in lines)
			{
				if (line.Length>0)
				{
					var xy = line.Split('\t');
					signal.x[iPoint] = (int)(double.Parse(xy[0])*60000);
					signal.y[iPoint++] = double.Parse(xy[1]);
				}
			}
			var myIntegrator = new MyIntegrator(signal, settings);
			var result = myIntegrator.Integrate();
			var tst = "result "+result+"\r\n";
			tst += "peaks "+myIntegrator.PeakCount+"\r\n";
			for(var iPeak=0; iPeak<myIntegrator.PeakCount; iPeak++)
			{
				var pk = myIntegrator.Peaks[iPeak];
				tst += String.Format("{0:0} {1:0} {2:0} {3:0.000} {4:0.000} {5:0.000} {6:0} {7:0} {8:0} {9:0} {10:0} {11} {12}\r\n",pk.peakHeight,pk.areaRaw,pk.areaCorrected,pk.xLeft/60000.0,pk.xTop/60000.0,pk.xRight/60000.0,pk.baselineLeft,pk.baselineRight,pk.scanLeft,pk.scanTop,pk.scanRight,pk.typeLeft,pk.typeRight);
			}
			var refFile = Path.Combine(@"..\..\ref.txt");
			var tstFile = Path.Combine(@"..\..\tst.txt");		
			File.WriteAllText(tstFile, tst);
			var p = new Process();
	        p.StartInfo.FileName = @"C:\Program Files (x86)\WinMerge\WinMergeU.exe";
	        p.StartInfo.Arguments = String.Format("\"{0}\" \"{1}\"",refFile,tstFile);
	        p.StartInfo.UseShellExecute = false;
	        p.StartInfo.RedirectStandardOutput = false;
	        p.Start();
	        p.WaitForExit();			
	        Close();
		}
	}
}
