using System;
using System.Globalization;
namespace Agilent.MassSpectrometry.DataAnalysis
{
	public struct Peak
	{
		public int rtLeft;
		public int rtTop;
		public int rtRight;
		public double areaRaw;
		public double areaCorrected;
		public double baselineLeft;
		public double baselineRight;
		public double peakHeight;
		public char typeLeft;
		public char typeRight;
		public ushort scanLeft;
		public ushort scanTop;
		public ushort scanRight;
		public Peak(int dummy)
		{
			this.rtLeft = 0;
			this.rtTop = 0;
			this.rtRight = 0;
			this.areaRaw = 0.0;
			this.areaCorrected = 0.0;
			this.baselineLeft = 0.0;
			this.baselineRight = 0.0;
			this.peakHeight = 0.0;
			this.typeLeft = '\0';
			this.typeRight = '\0';
			this.scanLeft = 0;
			this.scanTop = 0;
			this.scanRight = 0;
		}
		public void IncreaseStop(int a)
		{
			this.rtRight += a;
		}
		public override string ToString()
		{
			return string.Concat(new string[]
			{
				this.rtLeft.ToString(CultureInfo.CurrentUICulture),
				" ",
				this.rtTop.ToString(CultureInfo.CurrentUICulture),
				" ",
				this.rtRight.ToString(CultureInfo.CurrentUICulture),
				" ",
				this.areaRaw.ToString(CultureInfo.CurrentUICulture),
				" ",
				this.areaCorrected.ToString(CultureInfo.CurrentUICulture),
				" ",
				this.baselineLeft.ToString(CultureInfo.CurrentUICulture),
				" ",
				this.baselineRight.ToString(CultureInfo.CurrentUICulture),
				" ",
				this.peakHeight.ToString(CultureInfo.CurrentUICulture)
			});
		}
	}
}
