﻿using System;

namespace QuantReviewTest.Chrom
{
    internal class ChromGenerator
    {
        private readonly int _pointCount;
        private readonly int _maxResponse;
        private readonly int _averagePeakCount;
        private readonly Random _random = new Random();
        public ChromGenerator(int pointCount, int maxResponse, int averagePeakCount)
        {
            _pointCount = pointCount;
            _maxResponse = maxResponse;
            _averagePeakCount = averagePeakCount;
        }

        public double[] Generate()
        {
            var data = new double[_pointCount];
            for (var i = 0; i < _pointCount; i++)
                data[i] = _random.NextDouble() * _maxResponse / 20.0;

            var peakCount = _averagePeakCount * (1 + _random.NextDouble() / 2.0);
            for (var i = 0; i < peakCount; i++)
            {
                var x = (int)(_random.NextDouble() * _pointCount);
                var y = (int)(_random.NextDouble() * _maxResponse);

                data[x] = y;
                for (var ii = -3; ii < 1; ii++)
                {
                    if (x + ii < 0 || x + ii >= _pointCount) continue;
                    data[x + ii] = y;
                }
                for (var ii = 1; ii < 10; ii++)
                {
                    if (x + ii < 0 || x + ii >= _pointCount) continue;
                    data[x + ii] = y / (double)ii;
                }

            }
            return data;
        }
    }
}
